Index: branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/baseCfg_2view+depth.cfg
===================================================================
--- branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/baseCfg_2view+depth.cfg	(revision 437)
+++ branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/baseCfg_2view+depth.cfg	(revision 438)
@@ -105,4 +105,6 @@
 Frame8_l5:  B    7     7        0.68     0            0              0           3                4         -1 -3 -7 1         1      -2        5         1 1 1 1 0       1             -4                 2                  -1  
 
+ListCombination               : 1           # Use combined list for uni-prediction in B-slices
+
 #=========== Motion Search =============
 FastSearch                    : 1           # 0:Full search  1:TZ search
@@ -124,7 +126,6 @@
 LoopFilterOffsetInPPS         : 0           # Dbl params: 0=varying params in SliceHeader, param = base_param + GOP_offset_param; 1=constant params in PPS, param = base_param)
 LoopFilterDisable             : 0           # Disable deblocking filter (0=Filter, 1=No Filter) (mc)
-LoopFilterBetaOffset_div2     : 0           # base_param: -6 ~ 6 
-LoopFilterTcOffset_div2       : 0           # base_param: -6 ~ 6
-DeblockingFilterMetric        : 0           # blockiness metric (automatically configures deblocking parameters in bitstream)
+LoopFilterBetaOffset_div2     : 0           # base_param: -13 ~ 13 
+LoopFilterTcOffset_div2       : 0           # base_param: -13 ~ 13
 
 
Index: branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/baseCfg_2view.cfg
===================================================================
--- branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/baseCfg_2view.cfg	(revision 437)
+++ branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/baseCfg_2view.cfg	(revision 438)
@@ -57,4 +57,6 @@
 Frame8_l1:  B    7     7        0.68     0            0              0           3                4         -1 -3 -7 1         1      -2        5         1 1 1 1 0       1             -1                 2                  -1
 
+ListCombination               : 1           # Use combined list for uni-prediction in B-slices
+
 #=========== Motion Search =============
 FastSearch                    : 1           # 0:Full search  1:TZ search
@@ -77,7 +79,6 @@
 LoopFilterOffsetInPPS         : 0           # Dbl params: 0=varying params in SliceHeader, param = base_param + GOP_offset_param; 1=constant params in PPS, param = base_param)
 LoopFilterDisable             : 0           # Disable deblocking filter (0=Filter, 1=No Filter) (mc)
-LoopFilterBetaOffset_div2     : 0           # base_param: -6 ~ 6 
-LoopFilterTcOffset_div2       : 0           # base_param: -6 ~ 6
-DeblockingFilterMetric        : 0           # blockiness metric (automatically configures deblocking parameters in bitstream)
+LoopFilterBetaOffset_div2     : 0           # base_param: -13 ~ 13 
+LoopFilterTcOffset_div2       : 0           # base_param: -13 ~ 13
 
 
Index: branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/baseCfg_3view+depth.cfg
===================================================================
--- branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/baseCfg_3view+depth.cfg	(revision 437)
+++ branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/baseCfg_3view+depth.cfg	(revision 438)
@@ -105,4 +105,6 @@
 Frame8_l5:  B    7     7        0.68     0            0              0           3                4         -1 -3 -7 1         1      -2        5         1 1 1 1 0       1             -4                 2                  -1  
 
+ListCombination               : 1           # Use combined list for uni-prediction in B-slices
+
 #=========== Motion Search =============
 FastSearch                    : 1           # 0:Full search  1:TZ search
@@ -124,7 +126,7 @@
 LoopFilterOffsetInPPS         : 0           # Dbl params: 0=varying params in SliceHeader, param = base_param + GOP_offset_param; 1=constant params in PPS, param = base_param)
 LoopFilterDisable             : 0           # Disable deblocking filter (0=Filter, 1=No Filter) (mc)
-LoopFilterBetaOffset_div2     : 0           # base_param: -6 ~ 6 
-LoopFilterTcOffset_div2       : 0           # base_param: -6 ~ 6
-DeblockingFilterMetric        : 0           # blockiness metric (automatically configures deblocking parameters in bitstream)
+LoopFilterBetaOffset_div2     : 0           # base_param: -13 ~ 13 
+LoopFilterTcOffset_div2       : 0           # base_param: -13 ~ 13
+
 
 #=========== Misc. ============
Index: branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/baseCfg_3view.cfg
===================================================================
--- branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/baseCfg_3view.cfg	(revision 437)
+++ branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/baseCfg_3view.cfg	(revision 438)
@@ -69,4 +69,6 @@
 Frame8_l2:  B    7     7        0.68     0            0              0           3                4         -1 -3 -7 1         1      -2        5         1 1 1 1 0       1             -2                 2                  -1
 
+ListCombination               : 1           # Use combined list for uni-prediction in B-slices
+
 #=========== Motion Search =============
 FastSearch                    : 1           # 0:Full search  1:TZ search
@@ -89,7 +91,7 @@
 LoopFilterOffsetInPPS         : 0           # Dbl params: 0=varying params in SliceHeader, param = base_param + GOP_offset_param; 1=constant params in PPS, param = base_param)
 LoopFilterDisable             : 0           # Disable deblocking filter (0=Filter, 1=No Filter) (mc)
-LoopFilterBetaOffset_div2     : 0           # base_param: -6 ~ 6 
-LoopFilterTcOffset_div2       : 0           # base_param: -6 ~ 6
-DeblockingFilterMetric        : 0           # blockiness metric (automatically configures deblocking parameters in bitstream)
+LoopFilterBetaOffset_div2     : 0           # base_param: -13 ~ 13 
+LoopFilterTcOffset_div2       : 0           # base_param: -13 ~ 13
+
 
 #=========== Misc. ============
Index: branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/fullCfg.cfg
===================================================================
--- branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/fullCfg.cfg	(revision 437)
+++ branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/fullCfg.cfg	(revision 438)
@@ -109,4 +109,6 @@
 Frame8_l5:  B    7     7        0.68     0            0              0           3                4         -1 -3 -7 1         1      -2        5         1 1 1 1 0       1             -4                 2                  -1  
 
+ListCombination               : 1           # Use combined list for uni-prediction in B-slices
+
 #=========== Motion Search =============
 FastSearch                    : 1           # 0:Full search  1:TZ search
@@ -129,7 +131,7 @@
 LoopFilterOffsetInPPS         : 0           # Dbl params: 0=varying params in SliceHeader, param = base_param + GOP_offset_param; 1=constant params in PPS, param = base_param)
 LoopFilterDisable             : 0           # Disable deblocking filter (0=Filter, 1=No Filter) (mc)
-LoopFilterBetaOffset_div2     : 0           # base_param: -6 ~ 6 
-LoopFilterTcOffset_div2       : 0           # base_param: -6 ~ 6
-DeblockingFilterMetric        : 0           # blockiness metric (automatically configures deblocking parameters in bitstream)
+LoopFilterBetaOffset_div2     : 0           # base_param: -13 ~ 13 
+LoopFilterTcOffset_div2       : 0           # base_param: -13 ~ 13
+
 
 #=========== Misc. ============
Index: branches/HTM-DEV-0.2-dev/cfg/HEVC/HM/encoder_intra_main.cfg
===================================================================
--- branches/HTM-DEV-0.2-dev/cfg/HEVC/HM/encoder_intra_main.cfg	(revision 437)
+++ branches/HTM-DEV-0.2-dev/cfg/HEVC/HM/encoder_intra_main.cfg	(revision 438)
@@ -39,7 +39,6 @@
 LoopFilterOffsetInPPS         : 0           # Dbl params: 0=varying params in SliceHeader, param = base_param + GOP_offset_param; 1=constant params in PPS, param = base_param)
 LoopFilterDisable             : 0           # Disable deblocking filter (0=Filter, 1=No Filter)
-LoopFilterBetaOffset_div2     : 0           # base_param: -6 ~ 6
-LoopFilterTcOffset_div2       : 0           # base_param: -6 ~ 6
-DeblockingFilterMetric        : 0           # blockiness metric (automatically configures deblocking parameters in bitstream)
+LoopFilterBetaOffset_div2     : 0           # base_param: -13 ~ 13
+LoopFilterTcOffset_div2       : 0           # base_param: -13 ~ 13
 
 #=========== Misc. ============
Index: branches/HTM-DEV-0.2-dev/cfg/HEVC/HM/encoder_intra_main10.cfg
===================================================================
--- branches/HTM-DEV-0.2-dev/cfg/HEVC/HM/encoder_intra_main10.cfg	(revision 437)
+++ branches/HTM-DEV-0.2-dev/cfg/HEVC/HM/encoder_intra_main10.cfg	(revision 438)
@@ -39,7 +39,6 @@
 LoopFilterOffsetInPPS         : 0           # Dbl params: 0=varying params in SliceHeader, param = base_param + GOP_offset_param; 1=constant params in PPS, param = base_param)
 LoopFilterDisable             : 0           # Disable deblocking filter (0=Filter, 1=No Filter)
-LoopFilterBetaOffset_div2     : 0           # base_param: -6 ~ 6
-LoopFilterTcOffset_div2       : 0           # base_param: -6 ~ 6
-DeblockingFilterMetric        : 0           # blockiness metric (automatically configures deblocking parameters in bitstream)
+LoopFilterBetaOffset_div2     : 0           # base_param: -13 ~ 13
+LoopFilterTcOffset_div2       : 0           # base_param: -13 ~ 13
 
 #=========== Misc. ============
Index: branches/HTM-DEV-0.2-dev/cfg/HEVC/HM/encoder_lowdelay_P_main.cfg
===================================================================
--- branches/HTM-DEV-0.2-dev/cfg/HEVC/HM/encoder_lowdelay_P_main.cfg	(revision 437)
+++ branches/HTM-DEV-0.2-dev/cfg/HEVC/HM/encoder_lowdelay_P_main.cfg	(revision 438)
@@ -23,4 +23,5 @@
 Frame3:  P    3   3        0.4624   0            0               0           4                4         -1 -3 -7 -11       1      -1       5         0 1 1 1 1            
 Frame4:  P    4   1        0.578    0            0               0           4                4         -1 -4 -8 -12       1      -1       5         0 1 1 1 1
+ListCombination               : 1           # Use combined list for uni-prediction in B-slices
 
 #=========== Motion Search =============
@@ -44,7 +45,6 @@
 LoopFilterOffsetInPPS         : 0           # Dbl params: 0=varying params in SliceHeader, param = base_param + GOP_offset_param; 1=constant params in PPS, param = base_param)
 LoopFilterDisable             : 0           # Disable deblocking filter (0=Filter, 1=No Filter)
-LoopFilterBetaOffset_div2     : 0           # base_param: -6 ~ 6
-LoopFilterTcOffset_div2       : 0           # base_param: -6 ~ 6
-DeblockingFilterMetric        : 0           # blockiness metric (automatically configures deblocking parameters in bitstream)
+LoopFilterBetaOffset_div2     : 0           # base_param: -13 ~ 13
+LoopFilterTcOffset_div2       : 0           # base_param: -13 ~ 13
 
 #=========== Misc. ============
Index: branches/HTM-DEV-0.2-dev/cfg/HEVC/HM/encoder_lowdelay_P_main10.cfg
===================================================================
--- branches/HTM-DEV-0.2-dev/cfg/HEVC/HM/encoder_lowdelay_P_main10.cfg	(revision 437)
+++ branches/HTM-DEV-0.2-dev/cfg/HEVC/HM/encoder_lowdelay_P_main10.cfg	(revision 438)
@@ -23,4 +23,5 @@
 Frame3:  P    3   3        0.4624   0            0               0           4                4         -1 -3 -7 -11       1      -1       5         0 1 1 1 1            
 Frame4:  P    4   1        0.578    0            0               0           4                4         -1 -4 -8 -12       1      -1       5         0 1 1 1 1
+ListCombination               : 1           # Use combined list for uni-prediction in B-slices
 
 #=========== Motion Search =============
@@ -46,7 +47,6 @@
 LoopFilterOffsetInPPS         : 0           # Dbl params: 0=varying params in SliceHeader, param = base_param + GOP_offset_param; 1=constant params in PPS, param = base_param)
 LoopFilterDisable             : 0           # Disable deblocking filter (0=Filter, 1=No Filter)
-LoopFilterBetaOffset_div2     : 0           # base_param: -6 ~ 6
-LoopFilterTcOffset_div2       : 0           # base_param: -6 ~ 6
-DeblockingFilterMetric        : 0           # blockiness metric (automatically configures deblocking parameters in bitstream)
+LoopFilterBetaOffset_div2     : 0           # base_param: -13 ~ 13
+LoopFilterTcOffset_div2       : 0           # base_param: -13 ~ 13
 
 #=========== Misc. ============
Index: branches/HTM-DEV-0.2-dev/cfg/HEVC/HM/encoder_lowdelay_main.cfg
===================================================================
--- branches/HTM-DEV-0.2-dev/cfg/HEVC/HM/encoder_lowdelay_main.cfg	(revision 437)
+++ branches/HTM-DEV-0.2-dev/cfg/HEVC/HM/encoder_lowdelay_main.cfg	(revision 438)
@@ -23,4 +23,5 @@
 Frame3:  B    3   3        0.4624   0            0               0           4                4         -1 -3 -7 -11       1      -1       5         0 1 1 1 1            
 Frame4:  B    4   1        0.578    0            0               0           4                4         -1 -4 -8 -12       1      -1       5         0 1 1 1 1
+ListCombination               : 1           # Use combined list for uni-prediction in B-slices
 
 #=========== Motion Search =============
@@ -44,7 +45,6 @@
 LoopFilterOffsetInPPS         : 0           # Dbl params: 0=varying params in SliceHeader, param = base_param + GOP_offset_param; 1=constant params in PPS, param = base_param)
 LoopFilterDisable             : 0           # Disable deblocking filter (0=Filter, 1=No Filter)
-LoopFilterBetaOffset_div2     : 0           # base_param: -6 ~ 6
-LoopFilterTcOffset_div2       : 0           # base_param: -6 ~ 6
-DeblockingFilterMetric        : 0           # blockiness metric (automatically configures deblocking parameters in bitstream)
+LoopFilterBetaOffset_div2     : 0           # base_param: -13 ~ 13
+LoopFilterTcOffset_div2       : 0           # base_param: -13 ~ 13
 
 #=========== Misc. ============
Index: branches/HTM-DEV-0.2-dev/cfg/HEVC/HM/encoder_lowdelay_main10.cfg
===================================================================
--- branches/HTM-DEV-0.2-dev/cfg/HEVC/HM/encoder_lowdelay_main10.cfg	(revision 437)
+++ branches/HTM-DEV-0.2-dev/cfg/HEVC/HM/encoder_lowdelay_main10.cfg	(revision 438)
@@ -23,4 +23,5 @@
 Frame3:  B    3   3        0.4624   0            0               0           4                4         -1 -3 -7 -11       1      -1       5         0 1 1 1 1            
 Frame4:  B    4   1        0.578    0            0               0           4                4         -1 -4 -8 -12       1      -1       5         0 1 1 1 1
+ListCombination               : 1           # Use combined list for uni-prediction in B-slices
 
 #=========== Motion Search =============
@@ -44,7 +45,6 @@
 LoopFilterOffsetInPPS         : 0           # Dbl params: 0=varying params in SliceHeader, param = base_param + GOP_offset_param; 1=constant params in PPS, param = base_param)
 LoopFilterDisable             : 0           # Disable deblocking filter (0=Filter, 1=No Filter)
-LoopFilterBetaOffset_div2     : 0           # base_param: -6 ~ 6
-LoopFilterTcOffset_div2       : 0           # base_param: -6 ~ 6
-DeblockingFilterMetric        : 0           # blockiness metric (automatically configures deblocking parameters in bitstream)
+LoopFilterBetaOffset_div2     : 0           # base_param: -13 ~ 13
+LoopFilterTcOffset_div2       : 0           # base_param: -13 ~ 13
 
 #=========== Misc. ============
Index: branches/HTM-DEV-0.2-dev/cfg/HEVC/HM/encoder_randomaccess_main.cfg
===================================================================
--- branches/HTM-DEV-0.2-dev/cfg/HEVC/HM/encoder_randomaccess_main.cfg	(revision 437)
+++ branches/HTM-DEV-0.2-dev/cfg/HEVC/HM/encoder_randomaccess_main.cfg	(revision 438)
@@ -27,4 +27,5 @@
 Frame7:  B    5   4        0.68     0            0              0           2                4         -1 -5  1 3             1       1        5         1 0 1 1 1  
 Frame8:  B    7   4        0.68     0            0              0           2                4         -1 -3 -7 1             1      -2        5         1 1 1 1 0
+ListCombination               : 1           # Use combined list for uni-prediction in B-slices
 
 #=========== Motion Search =============
@@ -48,7 +49,7 @@
 LoopFilterOffsetInPPS         : 0           # Dbl params: 0=varying params in SliceHeader, param = base_param + GOP_offset_param; 1=constant params in PPS, param = base_param)
 LoopFilterDisable             : 0           # Disable deblocking filter (0=Filter, 1=No Filter)
-LoopFilterBetaOffset_div2     : 0           # base_param: -6 ~ 6
-LoopFilterTcOffset_div2       : 0           # base_param: -6 ~ 6
-DeblockingFilterMetric        : 0           # blockiness metric (automatically configures deblocking parameters in bitstream)
+LoopFilterBetaOffset_div2     : 0           # base_param: -13 ~ 13
+LoopFilterTcOffset_div2       : 0           # base_param: -13 ~ 13
+
 
 #=========== Misc. ============
Index: branches/HTM-DEV-0.2-dev/cfg/HEVC/HM/encoder_randomaccess_main10.cfg
===================================================================
--- branches/HTM-DEV-0.2-dev/cfg/HEVC/HM/encoder_randomaccess_main10.cfg	(revision 437)
+++ branches/HTM-DEV-0.2-dev/cfg/HEVC/HM/encoder_randomaccess_main10.cfg	(revision 438)
@@ -27,4 +27,5 @@
 Frame7:  B    5   4        0.68     0            0              0           2                4         -1 -5  1 3             1       1        5         1 0 1 1 1  
 Frame8:  B    7   4        0.68     0            0              0           2                4         -1 -3 -7 1             1      -2        5         1 1 1 1 0
+ListCombination               : 1           # Use combined list for uni-prediction in B-slices
 
 #=========== Motion Search =============
@@ -48,7 +49,6 @@
 LoopFilterOffsetInPPS         : 0           # Dbl params: 0=varying params in SliceHeader, param = base_param + GOP_offset_param; 1=constant params in PPS, param = base_param)
 LoopFilterDisable             : 0           # Disable deblocking filter (0=Filter, 1=No Filter)
-LoopFilterBetaOffset_div2     : 0           # base_param: -6 ~ 6
-LoopFilterTcOffset_div2       : 0           # base_param: -6 ~ 6
-DeblockingFilterMetric        : 0           # blockiness metric (automatically configures deblocking parameters in bitstream)
+LoopFilterBetaOffset_div2     : 0           # base_param: -13 ~ 13
+LoopFilterTcOffset_div2       : 0           # base_param: -13 ~ 13
 
 #=========== Misc. ============
Index: branches/HTM-DEV-0.2-dev/cfg/MV-HEVC/baseCfg_2view.cfg
===================================================================
--- branches/HTM-DEV-0.2-dev/cfg/MV-HEVC/baseCfg_2view.cfg	(revision 437)
+++ branches/HTM-DEV-0.2-dev/cfg/MV-HEVC/baseCfg_2view.cfg	(revision 438)
@@ -57,4 +57,6 @@
 Frame8_l1:  B    7     7        0.68     0            0              0           3                4         -1 -3 -7 1         1      -2        5         1 1 1 1 0       1             -1                 2                  -1
 
+ListCombination               : 1           # Use combined list for uni-prediction in B-slices
+
 #=========== Motion Search =============
 FastSearch                    : 1           # 0:Full search  1:TZ search
@@ -77,7 +79,6 @@
 LoopFilterOffsetInPPS         : 0           # Dbl params: 0=varying params in SliceHeader, param = base_param + GOP_offset_param; 1=constant params in PPS, param = base_param)
 LoopFilterDisable             : 0           # Disable deblocking filter (0=Filter, 1=No Filter) (mc)
-LoopFilterBetaOffset_div2     : 0           # base_param: -6 ~ 6 
-LoopFilterTcOffset_div2       : 0           # base_param: -6 ~ 6
-DeblockingFilterMetric        : 0           # blockiness metric (automatically configures deblocking parameters in bitstream)
+LoopFilterBetaOffset_div2     : 0           # base_param: -13 ~ 13 
+LoopFilterTcOffset_div2       : 0           # base_param: -13 ~ 13
 
 
Index: branches/HTM-DEV-0.2-dev/cfg/MV-HEVC/baseCfg_3view.cfg
===================================================================
--- branches/HTM-DEV-0.2-dev/cfg/MV-HEVC/baseCfg_3view.cfg	(revision 437)
+++ branches/HTM-DEV-0.2-dev/cfg/MV-HEVC/baseCfg_3view.cfg	(revision 438)
@@ -69,4 +69,6 @@
 Frame8_l2:  B    7     7        0.68     0            0              0           3                4         -1 -3 -7 1         1      -2        5         1 1 1 1 0       1             -2                 2                  -1
 
+ListCombination               : 1           # Use combined list for uni-prediction in B-slices
+
 #=========== Motion Search =============
 FastSearch                    : 1           # 0:Full search  1:TZ search
@@ -89,7 +91,7 @@
 LoopFilterOffsetInPPS         : 0           # Dbl params: 0=varying params in SliceHeader, param = base_param + GOP_offset_param; 1=constant params in PPS, param = base_param)
 LoopFilterDisable             : 0           # Disable deblocking filter (0=Filter, 1=No Filter) (mc)
-LoopFilterBetaOffset_div2     : 0           # base_param: -6 ~ 6 
-LoopFilterTcOffset_div2       : 0           # base_param: -6 ~ 6
-DeblockingFilterMetric        : 0           # blockiness metric (automatically configures deblocking parameters in bitstream)
+LoopFilterBetaOffset_div2     : 0           # base_param: -13 ~ 13 
+LoopFilterTcOffset_div2       : 0           # base_param: -13 ~ 13
+
 
 #=========== Misc. ============
Index: branches/HTM-DEV-0.2-dev/cfg/MV-HEVC/fullCfg.cfg
===================================================================
--- branches/HTM-DEV-0.2-dev/cfg/MV-HEVC/fullCfg.cfg	(revision 437)
+++ branches/HTM-DEV-0.2-dev/cfg/MV-HEVC/fullCfg.cfg	(revision 438)
@@ -73,4 +73,6 @@
 Frame8_l2:  B    7     7        0.68     0            0              0           3                4         -1 -3 -7 1         1      -2        5         1 1 1 1 0       1             -2                 2                  -1
 
+ListCombination               : 1           # Use combined list for uni-prediction in B-slices
+
 #=========== Motion Search =============
 FastSearch                    : 1           # 0:Full search  1:TZ search
@@ -93,7 +95,7 @@
 LoopFilterOffsetInPPS         : 0           # Dbl params: 0=varying params in SliceHeader, param = base_param + GOP_offset_param; 1=constant params in PPS, param = base_param)
 LoopFilterDisable             : 0           # Disable deblocking filter (0=Filter, 1=No Filter) (mc)
-LoopFilterBetaOffset_div2     : 0           # base_param: -6 ~ 6 
-LoopFilterTcOffset_div2       : 0           # base_param: -6 ~ 6
-DeblockingFilterMetric        : 0           # blockiness metric (automatically configures deblocking parameters in bitstream)
+LoopFilterBetaOffset_div2     : 0           # base_param: -13 ~ 13 
+LoopFilterTcOffset_div2       : 0           # base_param: -13 ~ 13
+
 
 #=========== Misc. ============