Index: branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/baseCfg_2view+depth.cfg
===================================================================
--- branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/baseCfg_2view+depth.cfg	(revision 438)
+++ branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/baseCfg_2view+depth.cfg	(revision 446)
@@ -26,8 +26,12 @@
 ScalabilityMask               : 3           # Scalability Mask             ( 1: View Scalability, 3: View + Depth Scalability )
 DimensionIdLen                : 2 1         # Number of bits to store Ids,  per scalability dimension, (m)
-ViewId                        : 0 0 1 1     # ViewId     (m) 
+ViewId                        : 1 1 0 0     # ViewId     (m) 
 DepthFlag                     : 0 1 0 1     # DepthFlag  (m) 
 LayerIdInNuh                  : 0           # Layer Id in NAL unit header, (0: no explicit signalling ) (m)
 SplittingFlag                 : 0           # Splitting Flag 
+
+#========== Camera parameters ==========
+CameraParameterFile           : cam_pars.txt  # camera parameter file
+CodedCamParsPrecision         : 5           # precision used for coding of camera parameters (in units of 2^(-x) luma samples)
 
 #======== Unit definition ================
@@ -105,6 +109,4 @@
 Frame8_l5:  B    7     7        0.68     0            0              0           3                4         -1 -3 -7 1         1      -2        5         1 1 1 1 0       1             -4                 2                  -1  
 
-ListCombination               : 1           # Use combined list for uni-prediction in B-slices
-
 #=========== Motion Search =============
 FastSearch                    : 1           # 0:Full search  1:TZ search
@@ -125,7 +127,8 @@
 DeblockingFilterControlPresent: 1           # Dbl control params present (0=not present, 1=present) (mc)
 LoopFilterOffsetInPPS         : 0           # Dbl params: 0=varying params in SliceHeader, param = base_param + GOP_offset_param; 1=constant params in PPS, param = base_param)
-LoopFilterDisable             : 0           # Disable deblocking filter (0=Filter, 1=No Filter) (mc)
-LoopFilterBetaOffset_div2     : 0           # base_param: -13 ~ 13 
-LoopFilterTcOffset_div2       : 0           # base_param: -13 ~ 13
+LoopFilterDisable             : 0 1         # Disable deblocking filter (0=Filter, 1=No Filter) (mc)
+LoopFilterBetaOffset_div2     : 0           # base_param: -6 ~ 6 
+LoopFilterTcOffset_div2       : 0           # base_param: -6 ~ 6
+DeblockingFilterMetric        : 0           # blockiness metric (automatically configures deblocking parameters in bitstream)
 
 
@@ -134,5 +137,5 @@
 
 #=========== Coding Tools =================
-SAO                           : 1           # Sample adaptive offset  (0: OFF, 1: ON) (mc)
+SAO                           : 1 0         # Sample adaptive offset  (0: OFF, 1: ON) (mc)
 AMP                           : 1           # Asymmetric motion partitions (0: OFF, 1: ON)
 TransformSkip                 : 1           # Transform skipping (0: OFF, 1: ON)
@@ -191,4 +194,22 @@
 RCForceIntraQP                      : 0                # Rate control: force intra QP to be equal to initial QP
 
+#========== multiview coding tools ==========
+
+
+#========== depth coding tools ==========
+VSO                       : 1                                      # use of view synthesis optimization for depth coding
+
+#========== view synthesis optimization (VSO) ==========
+
+VSOConfig                 : [cx0 B(cc1) I(s0.25 s0.5 s0.75)][cx1 B(oo0) I(s0.25 s0.5 s0.75)]  # VSO configuration string
+#VSOConfig                 : [ox0 B(cc1) I(s0.25 s0.5 s0.75)][cx1 B(oo0) I(s0.25 s0.5 s0.75)]  # VSO configuration string // FCO
+WVSO                      : 1                                    # use of WVSO (Depth distortion metric with a weighted depth fidelity term) 
+VSOWeight                 : 10                                   # weight of VSO ( in SAD case, cf. squared in SSE case )
+VSDWeight                 : 1                                    # weight of VSD ( in SAD case, cf. squared in SSE case )
+DWeight                   : 1                                    # weight of depth distortion itself ( in SAD case, cf. squared in SSE case )
+UseEstimatedVSD           : 1                                    # Model based VSD estimation instead of rendering based for some encoder decisions      
+
+
+
 ### DO NOT ADD ANYTHING BELOW THIS LINE ###
 ### DO NOT DELETE THE EMPTY LINE BELOW ###
Index: branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/baseCfg_2view.cfg
===================================================================
--- branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/baseCfg_2view.cfg	(revision 438)
+++ branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/baseCfg_2view.cfg	(revision 446)
@@ -21,4 +21,9 @@
 LayerIdInNuh                  : 0           # Layer Id in NAL unit header, (0: no explicit signalling ) (m)
 SplittingFlag                 : 0           # Splitting Flag 
+
+
+#========== Camera parameters ==========
+CameraParameterFile           : cam_pars.txt  # camera parameter file
+CodedCamParsPrecision         : 5           # precision used for coding of camera parameters (in units of 2^(-x) luma samples)
 
 #======== Unit definition ================
@@ -57,6 +62,4 @@
 Frame8_l1:  B    7     7        0.68     0            0              0           3                4         -1 -3 -7 1         1      -2        5         1 1 1 1 0       1             -1                 2                  -1
 
-ListCombination               : 1           # Use combined list for uni-prediction in B-slices
-
 #=========== Motion Search =============
 FastSearch                    : 1           # 0:Full search  1:TZ search
@@ -79,6 +82,7 @@
 LoopFilterOffsetInPPS         : 0           # Dbl params: 0=varying params in SliceHeader, param = base_param + GOP_offset_param; 1=constant params in PPS, param = base_param)
 LoopFilterDisable             : 0           # Disable deblocking filter (0=Filter, 1=No Filter) (mc)
-LoopFilterBetaOffset_div2     : 0           # base_param: -13 ~ 13 
-LoopFilterTcOffset_div2       : 0           # base_param: -13 ~ 13
+LoopFilterBetaOffset_div2     : 0           # base_param: -6 ~ 6 
+LoopFilterTcOffset_div2       : 0           # base_param: -6 ~ 6
+DeblockingFilterMetric        : 0           # blockiness metric (automatically configures deblocking parameters in bitstream)
 
 
Index: branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/baseCfg_3view+depth.cfg
===================================================================
--- branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/baseCfg_3view+depth.cfg	(revision 438)
+++ branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/baseCfg_3view+depth.cfg	(revision 446)
@@ -26,8 +26,12 @@
 ScalabilityMask               : 3           # Scalability Mask             ( 1: View Scalability, 3: View + Depth Scalability )
 DimensionIdLen                : 2 1         # Number of bits to store Ids,  per scalability dimension, (m)
-ViewId                        : 0 0 1 1 2 2 # ViewId     (m) 
+ViewId                        : 1 1 0 0 2 2 # ViewId     (m) 
 DepthFlag                     : 0 1 0 1 0 1 # DepthFlag  (m) 
 LayerIdInNuh                  : 0           # Layer Id in NAL unit header, (0: no explicit signalling ) (m)
 SplittingFlag                 : 0           # Splitting Flag 
+
+#========== Camera parameters ==========
+CameraParameterFile           : cam_pars.txt  # camera parameter file
+CodedCamParsPrecision         : 5           # precision used for coding of camera parameters (in units of 2^(-x) luma samples)
 
 #======== Unit definition ================
@@ -105,6 +109,4 @@
 Frame8_l5:  B    7     7        0.68     0            0              0           3                4         -1 -3 -7 1         1      -2        5         1 1 1 1 0       1             -4                 2                  -1  
 
-ListCombination               : 1           # Use combined list for uni-prediction in B-slices
-
 #=========== Motion Search =============
 FastSearch                    : 1           # 0:Full search  1:TZ search
@@ -125,8 +127,8 @@
 DeblockingFilterControlPresent: 1           # Dbl control params present (0=not present, 1=present) (mc)
 LoopFilterOffsetInPPS         : 0           # Dbl params: 0=varying params in SliceHeader, param = base_param + GOP_offset_param; 1=constant params in PPS, param = base_param)
-LoopFilterDisable             : 0           # Disable deblocking filter (0=Filter, 1=No Filter) (mc)
-LoopFilterBetaOffset_div2     : 0           # base_param: -13 ~ 13 
-LoopFilterTcOffset_div2       : 0           # base_param: -13 ~ 13
-
+LoopFilterDisable             : 0 1         # Disable deblocking filter (0=Filter, 1=No Filter) (mc)
+LoopFilterBetaOffset_div2     : 0           # base_param: -6 ~ 6 
+LoopFilterTcOffset_div2       : 0           # base_param: -6 ~ 6
+DeblockingFilterMetric        : 0           # blockiness metric (automatically configures deblocking parameters in bitstream)
 
 #=========== Misc. ============
@@ -134,5 +136,5 @@
 
 #=========== Coding Tools =================
-SAO                           : 1           # Sample adaptive offset  (0: OFF, 1: ON) (mc)
+SAO                           : 1 0         # Sample adaptive offset  (0: OFF, 1: ON) (mc)
 AMP                           : 1           # Asymmetric motion partitions (0: OFF, 1: ON)
 TransformSkip                 : 1           # Transform skipping (0: OFF, 1: ON)
@@ -191,4 +193,21 @@
 RCForceIntraQP                      : 0                # Rate control: force intra QP to be equal to initial QP
 
+#========== multiview coding tools ==========
+
+
+#========== depth coding tools ==========
+VSO                       : 1                                      # use of view synthesis optimization for depth coding
+
+#========== view synthesis optimization (VSO) ==========
+VSOConfig                 : [cx0 B(cc1) I(s0.25 s0.5 s0.75)][cx1 B(oo0) B(oo2) I(s0.25 s0.5 s0.75 s1.25 s1.5 s1.75)][cx2 B(cc1) I(s1.25 s1.5 s1.75)] # VSO configuration string
+#VSOConfig                 : [ox0 B(cc1) I(s0.25 s0.5 s0.75)][cx1 B(oo0) B(oo2) I(s0.25 s0.5 s0.75 s1.25 s1.5 s1.75)][ox2 B(cc1) I(s1.25 s1.5 s1.75)] # VSO configuration string for FCO = 1
+WVSO                      : 1                                    # use of WVSO (Depth distortion metric with a weighted depth fidelity term) 
+VSOWeight                 : 10                                   # weight of VSO ( in SAD case, cf. squared in SSE case )
+VSDWeight                 : 1                                    # weight of VSD ( in SAD case, cf. squared in SSE case )
+DWeight                   : 1                                    # weight of depth distortion itself ( in SAD case, cf. squared in SSE case )
+UseEstimatedVSD           : 1                                    # Model based VSD estimation instead of rendering based for some encoder decisions      
+
+
+
 ### DO NOT ADD ANYTHING BELOW THIS LINE ###
 ### DO NOT DELETE THE EMPTY LINE BELOW ###
Index: branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/baseCfg_3view.cfg
===================================================================
--- branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/baseCfg_3view.cfg	(revision 438)
+++ branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/baseCfg_3view.cfg	(revision 446)
@@ -23,4 +23,8 @@
 LayerIdInNuh                  : 0           # Layer Id in NAL unit header, (0: no explicit signalling ) (m)
 SplittingFlag                 : 0           # Splitting Flag 
+
+#========== Camera parameters ==========
+CameraParameterFile           : cam_pars.txt  # camera parameter file
+CodedCamParsPrecision         : 5           # precision used for coding of camera parameters (in units of 2^(-x) luma samples)
 
 #======== Unit definition ================
@@ -69,6 +73,4 @@
 Frame8_l2:  B    7     7        0.68     0            0              0           3                4         -1 -3 -7 1         1      -2        5         1 1 1 1 0       1             -2                 2                  -1
 
-ListCombination               : 1           # Use combined list for uni-prediction in B-slices
-
 #=========== Motion Search =============
 FastSearch                    : 1           # 0:Full search  1:TZ search
@@ -91,7 +93,7 @@
 LoopFilterOffsetInPPS         : 0           # Dbl params: 0=varying params in SliceHeader, param = base_param + GOP_offset_param; 1=constant params in PPS, param = base_param)
 LoopFilterDisable             : 0           # Disable deblocking filter (0=Filter, 1=No Filter) (mc)
-LoopFilterBetaOffset_div2     : 0           # base_param: -13 ~ 13 
-LoopFilterTcOffset_div2       : 0           # base_param: -13 ~ 13
-
+LoopFilterBetaOffset_div2     : 0           # base_param: -6 ~ 6 
+LoopFilterTcOffset_div2       : 0           # base_param: -6 ~ 6
+DeblockingFilterMetric        : 0           # blockiness metric (automatically configures deblocking parameters in bitstream)
 
 #=========== Misc. ============
Index: branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/fullCfg.cfg
===================================================================
--- branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/fullCfg.cfg	(revision 438)
+++ branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/fullCfg.cfg	(revision 446)
@@ -30,8 +30,13 @@
 ScalabilityMask               : 3           # Scalability Mask             ( 1: View Scalability, 3: View + Depth Scalability )
 DimensionIdLen                : 2 1         # Number of bits to store Ids,  per scalability dimension, (m)
-ViewId                        : 0 0 1 1 2 2 # ViewId     (m) 
+ViewId                        : 1 1 0 0 2 2 # ViewId     (m) 
 DepthFlag                     : 0 1 0 1 0 1 # DepthFlag  (m) 
 LayerIdInNuh                  : 0           # Layer Id in NAL unit header, (0: no explicit signalling ) (m)
 SplittingFlag                 : 0           # Splitting Flag 
+
+#========== Camera parameters ==========
+BaseViewCameraNumbers         : 3 1 5       # camera numbers of coded views ( in coding order per view )
+CameraParameterFile           : cam_pars.txt  # camera parameter file
+CodedCamParsPrecision         : 5           # precision used for coding of camera parameters (in units of 2^(-x) luma samples)
 
 #======== Unit definition ================
@@ -109,6 +114,4 @@
 Frame8_l5:  B    7     7        0.68     0            0              0           3                4         -1 -3 -7 1         1      -2        5         1 1 1 1 0       1             -4                 2                  -1  
 
-ListCombination               : 1           # Use combined list for uni-prediction in B-slices
-
 #=========== Motion Search =============
 FastSearch                    : 1           # 0:Full search  1:TZ search
@@ -120,5 +123,5 @@
 
 #======== Quantization =============
-QP                            : 25 30       # QP ( mc )
+QP                            : 25 30 25 30 25 30      # QP ( mc )
 MaxDeltaQP                    : 0           # CU-based multi-QP optimization
 MaxCuDQPDepth                 : 0           # Max depth of a minimum CuDQP for sub-LCU-level delta QP
@@ -130,8 +133,8 @@
 DeblockingFilterControlPresent: 1           # Dbl control params present (0=not present, 1=present) (mc)
 LoopFilterOffsetInPPS         : 0           # Dbl params: 0=varying params in SliceHeader, param = base_param + GOP_offset_param; 1=constant params in PPS, param = base_param)
-LoopFilterDisable             : 0           # Disable deblocking filter (0=Filter, 1=No Filter) (mc)
-LoopFilterBetaOffset_div2     : 0           # base_param: -13 ~ 13 
-LoopFilterTcOffset_div2       : 0           # base_param: -13 ~ 13
-
+LoopFilterDisable             : 0 1         # Disable deblocking filter (0=Filter, 1=No Filter) (mc)
+LoopFilterBetaOffset_div2     : 0           # base_param: -6 ~ 6 
+LoopFilterTcOffset_div2       : 0           # base_param: -6 ~ 6
+DeblockingFilterMetric        : 0           # blockiness metric (automatically configures deblocking parameters in bitstream)
 
 #=========== Misc. ============
@@ -139,5 +142,5 @@
 
 #=========== Coding Tools =================
-SAO                           : 1           # Sample adaptive offset  (0: OFF, 1: ON) (mc)
+SAO                           : 1 0         # Sample adaptive offset  (0: OFF, 1: ON) (mc)
 AMP                           : 1           # Asymmetric motion partitions (0: OFF, 1: ON)
 TransformSkip                 : 1           # Transform skipping (0: OFF, 1: ON)
@@ -196,4 +199,21 @@
 RCForceIntraQP                      : 0                # Rate control: force intra QP to be equal to initial QP
 
+#========== multiview coding tools ==========
+
+
+#========== depth coding tools ==========
+VSO                       : 1                                      # use of view synthesis optimization for depth coding
+
+#========== view synthesis optimization (VSO) ==========
+VSOConfig                 : [cx0 B(cc1) I(s0.25 s0.5 s0.75)][cx1 B(oo0) B(oo2) I(s0.25 s0.5 s0.75 s1.25 s1.5 s1.75)][cx2 B(cc1) I(s1.25 s1.5 s1.75)] # VSO configuration string
+#VSOConfig                 : [ox0 B(cc1) I(s0.25 s0.5 s0.75)][cx1 B(oo0) B(oo2) I(s0.25 s0.5 s0.75 s1.25 s1.5 s1.75)][ox2 B(cc1) I(s1.25 s1.5 s1.75)] # VSO configuration string for FCO = 1
+WVSO                      : 1                                    # use of WVSO (Depth distortion metric with a weighted depth fidelity term) 
+VSOWeight                 : 10                                   # weight of VSO ( in SAD case, cf. squared in SSE case )
+VSDWeight                 : 1                                    # weight of VSD ( in SAD case, cf. squared in SSE case )
+DWeight                   : 1                                    # weight of depth distortion itself ( in SAD case, cf. squared in SSE case )
+UseEstimatedVSD           : 1                                    # Model based VSD estimation instead of rendering based for some encoder decisions      
+
+
+
 ### DO NOT ADD ANYTHING BELOW THIS LINE ###
 ### DO NOT DELETE THE EMPTY LINE BELOW ###
Index: branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/seqCfg_Balloons.cfg
===================================================================
--- branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/seqCfg_Balloons.cfg	(revision 438)
+++ branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/seqCfg_Balloons.cfg	(revision 446)
@@ -5,4 +5,4 @@
 FrameRate                 : 30                                     # frame rate in frames per second
 FramesToBeEncoded         : 300                                    # number of frames to be coded
-#BaseViewCameraNumbers     : 3 1 5                                  # camera numbers of coded views (in coding order)
+BaseViewCameraNumbers     : 3 1 5                                  # camera numbers of coded views (in coding order)
 
Index: branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/seqCfg_GhostTownFly.cfg
===================================================================
--- branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/seqCfg_GhostTownFly.cfg	(revision 438)
+++ branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/seqCfg_GhostTownFly.cfg	(revision 446)
@@ -5,4 +5,4 @@
 FrameRate                 : 25                                     # frame rate in frames per second
 FramesToBeEncoded         : 250                                    # number of frames to be coded
-#BaseViewCameraNumbers     : 5 9 1                                  # camera numbers of coded views (in coding order)
+BaseViewCameraNumbers     : 5 9 1                                  # camera numbers of coded views (in coding order)
 
Index: branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/seqCfg_Kendo.cfg
===================================================================
--- branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/seqCfg_Kendo.cfg	(revision 438)
+++ branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/seqCfg_Kendo.cfg	(revision 446)
@@ -5,4 +5,4 @@
 FrameRate                 : 30                                     # frame rate in frames per second
 FramesToBeEncoded         : 300                                    # number of frames to be coded
-#BaseViewCameraNumbers     : 3 1 5                                  # camera numbers of coded views (in coding order)
+BaseViewCameraNumbers     : 3 1 5                                  # camera numbers of coded views (in coding order)
 
Index: branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/seqCfg_Newspaper.cfg
===================================================================
--- branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/seqCfg_Newspaper.cfg	(revision 438)
+++ branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/seqCfg_Newspaper.cfg	(revision 446)
@@ -5,4 +5,4 @@
 FrameRate                 : 30                                     # frame rate in frames per second
 FramesToBeEncoded         : 300                                    # number of frames to be coded
-#BaseViewCameraNumbers     : 4 2 6                                  # camera numbers of coded views (in coding order)
+BaseViewCameraNumbers     : 4 2 6                                  # camera numbers of coded views (in coding order)
 
Index: branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/seqCfg_PoznanHall2.cfg
===================================================================
--- branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/seqCfg_PoznanHall2.cfg	(revision 438)
+++ branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/seqCfg_PoznanHall2.cfg	(revision 446)
@@ -5,4 +5,4 @@
 FrameRate                 : 25                                     # frame rate in frames per second
 FramesToBeEncoded         : 200                                    # number of frames to be coded
-#BaseViewCameraNumbers     : 6 7 5                                  # camera numbers of coded views (in coding order)
+BaseViewCameraNumbers     : 6 7 5                                  # camera numbers of coded views (in coding order)
 
Index: branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/seqCfg_PoznanStreet.cfg
===================================================================
--- branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/seqCfg_PoznanStreet.cfg	(revision 438)
+++ branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/seqCfg_PoznanStreet.cfg	(revision 446)
@@ -5,4 +5,4 @@
 FrameRate                 : 25                                     # frame rate in frames per second
 FramesToBeEncoded         : 250                                    # number of frames to be coded
-#BaseViewCameraNumbers     : 4 5 3                                  # camera numbers of coded views (in coding order)
+BaseViewCameraNumbers     : 4 5 3                                  # camera numbers of coded views (in coding order)
 
Index: branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/seqCfg_UndoDancer.cfg
===================================================================
--- branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/seqCfg_UndoDancer.cfg	(revision 438)
+++ branches/HTM-DEV-0.2-dev/cfg/3D-HEVC/seqCfg_UndoDancer.cfg	(revision 446)
@@ -5,4 +5,4 @@
 FrameRate                 : 25                                     # frame rate in frames per second
 FramesToBeEncoded         : 250                                    # number of frames to be coded
-#BaseViewCameraNumbers     : 5 1 9                                  # camera numbers of coded views (in coding order)
+BaseViewCameraNumbers     : 5 1 9                                  # camera numbers of coded views (in coding order)
 