Index: branches/SHM-4.0-dev/source/Lib/TLibCommon/TypeDef.h
===================================================================
--- branches/SHM-4.0-dev/source/Lib/TLibCommon/TypeDef.h	(revision 451)
+++ branches/SHM-4.0-dev/source/Lib/TLibCommon/TypeDef.h	(revision 452)
@@ -78,5 +78,4 @@
 #define VPS_MOVE_DIR_DEPENDENCY_FLAG     1      ///< JCTVC-M0268: Move the syntax element direct_dependency_flag to follow the syntax element dimension_id
 #define VPS_PROFILE_OUTPUT_LAYERS        1      ///< JCTVC-M0268: Signal profile information and output layer information as in Sec. 3 of M0268v2
-#define SPS_SUB_LAYER_INFO               1      ///< JCTVC-M0268: Do not signal sps_max_sub_layers_minus1 and sps_temporal_id_nesting_flag for nuh_layer_id greater than 0
 #define M0457_PREDICTION_INDICATIONS     1
 #define M0040_ADAPTIVE_RESOLUTION_CHANGE 1
Index: branches/SHM-4.0-dev/source/Lib/TLibDecoder/TDecCAVLC.cpp
===================================================================
--- branches/SHM-4.0-dev/source/Lib/TLibDecoder/TDecCAVLC.cpp	(revision 451)
+++ branches/SHM-4.0-dev/source/Lib/TLibDecoder/TDecCAVLC.cpp	(revision 452)
@@ -536,5 +536,5 @@
 }
 
-#if SPS_SUB_LAYER_INFO
+#if SVC_EXTENSION
 Void TDecCavlc::parseSPS(TComSPS* pcSPS, ParameterSetManagerDecoder *parameterSetManager)
 #else
@@ -548,5 +548,5 @@
   UInt  uiCode;
   READ_CODE( 4,  uiCode, "sps_video_parameter_set_id");          pcSPS->setVPSId        ( uiCode );
-#if SPS_SUB_LAYER_INFO
+#if SVC_EXTENSION
   if(pcSPS->getLayerId() == 0)
   {
@@ -556,5 +556,5 @@
   
     READ_FLAG( uiCode, "sps_temporal_id_nesting_flag" );               pcSPS->setTemporalIdNestingFlag ( uiCode > 0 ? true : false );
-#if SPS_SUB_LAYER_INFO
+#if SVC_EXTENSION
   }
   else
@@ -563,13 +563,13 @@
     pcSPS->setTemporalIdNestingFlag( parameterSetManager->getPrefetchedVPS(pcSPS->getVPSId())->getTemporalNestingFlag() );
   }
-#endif 
 #if IL_SL_SIGNALLING_N0371
   pcSPS->setVPS( parameterSetManager->getPrefetchedVPS(pcSPS->getVPSId()) );
   pcSPS->setSPS( pcSPS->getLayerId(), pcSPS );
 #endif
+#endif
   if ( pcSPS->getMaxTLayers() == 1 )
   {
     // sps_temporal_id_nesting_flag must be 1 when sps_max_sub_layers_minus1 is 0
-#if SPS_SUB_LAYER_INFO
+#if SVC_EXTENSION
     assert( pcSPS->getTemporalIdNestingFlag() == true );
 #else
Index: branches/SHM-4.0-dev/source/Lib/TLibDecoder/TDecCAVLC.h
===================================================================
--- branches/SHM-4.0-dev/source/Lib/TLibDecoder/TDecCAVLC.h	(revision 451)
+++ branches/SHM-4.0-dev/source/Lib/TLibDecoder/TDecCAVLC.h	(revision 452)
@@ -72,4 +72,5 @@
   Void  parseQtRootCbf      ( UInt uiAbsPartIdx, UInt& uiQtRootCbf );
   Void  parseVPS            ( TComVPS* pcVPS );
+#if SPS_EXTENSION
 #if VPS_EXTNS
   Void  parseVPSExtension   ( TComVPS* pcVPS );
@@ -82,12 +83,9 @@
   Void  parseRepFormat      ( RepFormat *repFormat );
 #endif
-#if SPS_SUB_LAYER_INFO
   Void  parseSPS            ( TComSPS* pcSPS, ParameterSetManagerDecoder *parameterSetManager );
-#else
+  Void  parseSPSExtension    ( TComSPS* pcSPS );
+#else //SVC_EXTENSION
   Void  parseSPS            ( TComSPS* pcSPS );
-#endif
-#if SPS_EXTENSION
-  Void parseSPSExtension    ( TComSPS* pcSPS );
-#endif
+#endif //SVC_EXTENSION
   Void  parsePPS            ( TComPPS* pcPPS);
   Void  parseVUI            ( TComVUI* pcVUI, TComSPS* pcSPS );
Index: branches/SHM-4.0-dev/source/Lib/TLibDecoder/TDecEntropy.h
===================================================================
--- branches/SHM-4.0-dev/source/Lib/TLibDecoder/TDecEntropy.h	(revision 451)
+++ branches/SHM-4.0-dev/source/Lib/TLibDecoder/TDecEntropy.h	(revision 452)
@@ -66,5 +66,5 @@
 
   virtual Void  parseVPS                  ( TComVPS* pcVPS )                       = 0;
-#if SPS_SUB_LAYER_INFO
+#if SVC_EXTENSION
   virtual Void  parseSPS                  ( TComSPS* pcSPS, ParameterSetManagerDecoder *parameterSetManager )           = 0;
 #else
@@ -134,5 +134,5 @@
   Void    resetEntropy                ( TComSlice* p)           { m_pcEntropyDecoderIf->resetEntropy(p);                    }
   Void    decodeVPS                   ( TComVPS* pcVPS ) { m_pcEntropyDecoderIf->parseVPS(pcVPS); }
-#if SPS_SUB_LAYER_INFO
+#if SVC_EXTENSION
   Void    decodeSPS                   ( TComSPS* pcSPS, ParameterSetManagerDecoder *parameterSetManager )    { m_pcEntropyDecoderIf->parseSPS(pcSPS, parameterSetManager);                    }
 #else
Index: branches/SHM-4.0-dev/source/Lib/TLibDecoder/TDecSbac.h
===================================================================
--- branches/SHM-4.0-dev/source/Lib/TLibDecoder/TDecSbac.h	(revision 451)
+++ branches/SHM-4.0-dev/source/Lib/TLibDecoder/TDecSbac.h	(revision 452)
@@ -76,5 +76,5 @@
   Void  setBitstream              ( TComInputBitstream* p  ) { m_pcBitstream = p; m_pcTDecBinIf->init( p ); }
   Void  parseVPS                  ( TComVPS* /*pcVPS*/ ) {}
-#if SPS_SUB_LAYER_INFO
+#if SVC_EXTENSION
   Void  parseSPS                  ( TComSPS* /*pcSPS*/, ParameterSetManagerDecoder * /*parameterSetManager*/ ) {}
 #else
Index: branches/SHM-4.0-dev/source/Lib/TLibDecoder/TDecTop.cpp
===================================================================
--- branches/SHM-4.0-dev/source/Lib/TLibDecoder/TDecTop.cpp	(revision 451)
+++ branches/SHM-4.0-dev/source/Lib/TLibDecoder/TDecTop.cpp	(revision 452)
@@ -1378,17 +1378,6 @@
 #if SVC_EXTENSION
   sps->setLayerId(m_layerId);
-#endif
-
-#if SPS_SUB_LAYER_INFO
   m_cEntropyDecoder.decodeSPS( sps, &m_parameterSetManagerDecoder[0] );
-#else
-  m_cEntropyDecoder.decodeSPS( sps );
-#endif
-#if SVC_EXTENSION
   m_parameterSetManagerDecoder[m_layerId].storePrefetchedSPS(sps);
-#else
-  m_parameterSetManagerDecoder.storePrefetchedSPS(sps);
-#endif
-#if SVC_EXTENSION
 #if !REPN_FORMAT_IN_VPS   // ILRP can only be initialized at activation  
   if(m_numLayer>0)
@@ -1397,5 +1386,8 @@
   }
 #endif
-#endif
+#else //SVC_EXTENSION
+  m_cEntropyDecoder.decodeSPS( sps );
+  m_parameterSetManagerDecoder.storePrefetchedSPS(sps);
+#endif //SVC_EXTENSION
 }
 
Index: branches/SHM-4.0-dev/source/Lib/TLibEncoder/TEncCavlc.cpp
===================================================================
--- branches/SHM-4.0-dev/source/Lib/TLibEncoder/TEncCavlc.cpp	(revision 451)
+++ branches/SHM-4.0-dev/source/Lib/TLibEncoder/TEncCavlc.cpp	(revision 452)
@@ -448,5 +448,5 @@
 #endif
   WRITE_CODE( pcSPS->getVPSId (),          4,       "sps_video_parameter_set_id" );
-#if SPS_SUB_LAYER_INFO
+#if SVC_EXTENSION
   if(pcSPS->getLayerId() == 0)
   {
@@ -454,5 +454,5 @@
     WRITE_CODE( pcSPS->getMaxTLayers() - 1,  3,       "sps_max_sub_layers_minus1" );
     WRITE_FLAG( pcSPS->getTemporalIdNestingFlag() ? 1 : 0,                             "sps_temporal_id_nesting_flag" );
-#if SPS_SUB_LAYER_INFO
+#if SVC_EXTENSION
   }
 #endif